VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Lib_Class"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'-----------------------------------------------------------------------------
'-- Class Name: Lib_Class
'-- Created   : 19-07-2002
'-- Author    : Gary Noble
'-- Copyright : Gary Noble 2002
'-----------------------------------------------------------------------------
'-- Description: Reads The Text And Returns The number Of Subs, Function,
'--              Lines, WhiteSpaces
'-----------------------------------------------------------------------------

Private mvarClassType As String 'local copy
Private mvarClassName As String 'local copy
Private mvarNumLines As Long 'local copy
Private mvarNumSubs As Variant 'local copy
Private mvarNumFunctions As Long 'local copy
Private mvarNumProperties As Long 'local copy
Private mvarCountComments As Boolean 'local copy
Private mvarCountSpace As Boolean 'local copy
Private mvarSubs As Collection 'local copy
Private mvarLastErrorMessage As String
Private mvarIsFunction As Boolean
Public Event Process(StatusMsg As String)

Public Property Get LastErrorMessage() As String
LastErrorMessage = mvarLastErrorMessage
End Property
Public Property Set Subs(ByVal vData As Collection)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.Subs = Form1
    Set mvarSubs = vData
End Property

Public Property Get Subs() As Collection
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Subs
    Set Subs = mvarSubs
End Property

Public Property Let CountSpace(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.CountSpace = 5
    mvarCountSpace = vData
End Property

Public Property Get CountSpace() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.CountSpace
    CountSpace = mvarCountSpace
End Property

Public Property Let CountComments(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.CountComments = 5
    mvarCountComments = vData
End Property

Public Property Get CountComments() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.CountComments
    CountComments = mvarCountComments
End Property






Public Property Get NumProperties() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.NumProperties
    NumProperties = mvarNumProperties
End Property






Public Property Get NumFunctions() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.NumFunctions
    NumFunctions = mvarNumFunctions
End Property




Public Property Get NumSubs() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.NumSubs
   
   NumSubs = mvarNumSubs
   
End Property



Public Property Let NumLines(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.NumLines = 5
    mvarNumLines = vData
End Property


Public Property Get NumLines() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.NumLines
    NumLines = mvarNumLines
End Property



Public Property Let ClassName(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ClassName = 5
    mvarClassName = vData
End Property


Public Property Get ClassName() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ClassName
    ClassName = mvarClassName
End Property



Public Property Let ClassType(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ClassType = 5
    mvarClassType = vData
End Property


Public Property Get ClassType() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ClassType
    ClassType = mvarClassType
End Property


Public Function Read(ByVal strText As String) As Boolean

On Error GoTo errHandle

Dim fileNum As Long
Dim aSub As lib_Sub
Dim lineOfFile() As String
Dim keyWords As Variant



Set aSub = New lib_Sub
aSub.SubType = "Declarations"

'RaiseEvent Process("Processing " & fileToRead)

lineOfFile() = Split(strText, vbCrLf)

Dim i As Long


For i = LBound(lineOfFile) To UBound(lineOfFile)
  'Read the first word on the line
  If lineOfFile(i) <> "" Then
    keyWords = Split(lineOfFile(i))
  Else
    keyWords(0) = ""
  End If
  
  Select Case UCase(keyWords(0))
    Case "PRIVATE", "PUBLIC"
      'Check to see if we are in a function
      If Not mvarIsFunction Then
        'Check to See if we are reading a Function
        Select Case UCase(keyWords(1))
          Case "FUNCTION", "SUB", "PROPERTY"   'This is a function
            mvarIsFunction = True
            Call mvarSubs.Add(aSub)
            Set aSub = New lib_Sub
            If UCase(keyWords(1)) = "PROPERTY" Then
              aSub.SubName = Split(keyWords(3), "(")(0)
            Else
              aSub.SubName = Split(keyWords(2), "(")(0)
            End If
            aSub.SubType = keyWords(1)
            aSub.NumLines = aSub.NumLines + 1
          Case Else  'This is just a variable declaration
            If (Left(Trim(lineOfFile(i)), 1) = "'" And mvarCountComments = False) Or (lineOfFile(i) = "" And mvarCountSpace = False) Then
            Else
              aSub.NumLines = aSub.NumLines + 1
            End If
        End Select
      Else  'We are in a function
        If (Left(Trim(lineOfFile), 1) = "'" And mvarCountComments = False) Or (lineOfFile(i) = "" And mvarCountSpace = False) Then
        Else
          aSub.NumLines = aSub.NumLines + 1
        End If
        aSub.NumLines = aSub.NumLines + 1
      End If
   Case Else
      If mvarIsFunction Then
        Select Case UCase(keyWords(0))
          Case "END"  'The function is ending
            mvarIsFunction = False
            aSub.NumLines = aSub.NumLines + 1
          Case Else
            
            If (Left(lineOfFile(i), 1) = "'" And mvarCountComments = False) Or (lineOfFile(i) = "" And mvarCountSpace = False) Then  'This is a comment line
            Else
              aSub.NumLines = aSub.NumLines + 1
            End If
        End Select
      Else
        Select Case UCase(keyWords(0))
          Case "FUNCTION", "SUB", "PROPERTY"
            mvarIsFunction = True
            Call mvarSubs.Add(aSub)
            Set aSub = New lib_Sub
             If UCase(keyWords(1)) = "PROPERTY" Then
              aSub.SubName = Split(keyWords(2), "(")(0)
            Else
              aSub.SubName = Split(keyWords(1), "(")(0)
            End If
            aSub.SubType = keyWords(0)
            aSub.NumLines = aSub.NumLines + 1
         Case Else
            If (Left(lineOfFile(i), 1) = "'" And mvarCountComments = False) Or (lineOfFile(i) = "" And mvarCountSpace = False) Then
            Else
              aSub.NumLines = aSub.NumLines + 1
            End If
        End Select
      End If
    End Select
   
Next i

Call mvarSubs.Add(aSub)  'Add the last sub routine in

Read = True

'Loop through and determine the

For Each aSub In Me.Subs
  Select Case aSub.SubType
    Case "Function"
      mvarNumFunctions = mvarNumFunctions + 1
      
    Case "Property"
      mvarNumProperties = mvarNumProperties + 1
      
    Case "Sub"
      mvarNumSubs = mvarNumSubs + 1
  End Select
  mvarNumLines = mvarNumLines + aSub.NumLines
Next aSub



Exit Function

errHandle:
mvarLastErrorMessage = Err.Description
Close #fileNum
Read = False
End Function

Private Sub Class_Initialize()
mvarIsFunction = False
Set mvarSubs = New Collection
End Sub

Private Sub Class_Terminate()
Set mvarSubs = Nothing
End Sub

