VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cHighlighter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
        
    Const BlueKeyWords  As String = "*(*)*Attribute*#Const*#Else*#ElseIf*#End If*#If*Alias*Alias*And*As*Base*Binary*Boolean*Byte*ByVal*Call*Case*CBool*CByte*CCur*CDate*CDbl*CDec*CInt*CLng*Close*Compare*Const*CSng*CStr*Currency*CVar*CVErr*Decimal*Declare*DefBool*DefByte*DefCur*DefDate*DefDbl*DefDec*DefInt*DefLng*DefObj*DefSng*DefStr*DefVar*Dim*Do*Double*Each*Else*ElseIf*End*Enum*Eqv*Erase*Error*Exit*Explicit*False*For*Function*Get*Global*GoSub*GoTo*If*Imp*In*Input*Input*Integer*Is*LBound*Let*Lib*Like*Line*Lock*Long*Loop*LSet*Name*New*Next*Not*Object*On*Open*Option*Or*Output*Print*Private*Property*Public*Put*Random*Read*ReDim*Resume*Return*RSet*Seek*Select*Set*Single*Spc*Static*String*Stop*Sub*Tab*Then*Then*True*Type*UBound*Unlock*Variant*Wend*While*With*Xor*Nothing*To*"
        
    Public TERMINAL_OPENER As String
    Public TERMINAL_CLOSER As String
    Public STRING_OPENER As String
    Public STRING_CLOSER As String
    Public COMMENT_OPENER As String
    Public COMMENT_CLOSER As String
    Public KEYWORD_OPENER As String
    Public KEYWORD_CLOSER As String
    Public IsNewLine As Boolean
    
    Public Function HighlightCode(strToColour As String, ByVal lLanguage As Language)                'As String
    
        KEYWORD_OPENER = KEYWORD_OPENER & "\cf1 "
        KEYWORD_CLOSER = KEYWORD_CLOSER & "\cf4 "

        strToColour = Replace(strToColour, vbTab, "\tab")   ' '== Get rid of tabs

        Select Case CLng(lLanguage)
            Case LANGUAGE_HTML: HighlightCode = ProcessHTML(strToColour)
            Case LANGUAGE_VB: HighlightCode = ProcessVB(strToColour)
        End Select
    
    End Function

    
    Private Function ProcessVB(sInput As String)     'As String

        Dim objAppend       As New Lib_AppendString
        
        Dim sOutput         As String
        Dim sTemp           As String
        Dim lCount          As Long
        Dim lMax            As Long
        Dim sChar           As String
        Dim bInString       As Boolean
        Dim bInComment      As Boolean
      
        lMax = Len(sInput)
       
        bInString = False
        bInComment = False
        
        For lCount = 1 To lMax
            sChar = Mid$(sInput, lCount, 1)
            If IsVBTerminal(sChar) Then
                If sChar = Chr(34) And bInString And Not bInComment Then        '== Close a string
                      objAppend.Append STRING_OPENER & "\cf0" & sTemp & """" & STRING_CLOSER & "\cf0"    '& Replace(sTemp & sChar, " ", " ")
                    bInString = False
                    sTemp = " "
                ElseIf sChar = Chr(34) And Not (bInString Or bInComment) Then '== Open a string
                    bInString = True
                    objAppend.Append FormatVBWord(sTemp) & "\cf4"
                    sTemp = Chr(34)
                ElseIf Not (bInString Or bInComment) And sChar = "'" Then
                    bInComment = True
                    objAppend.Append FormatVBWord(sTemp) & "\cf4"
                    sTemp = "'"
                ElseIf bInComment And sChar = vbCr Or sChar = "" Then
                    objAppend.Append COMMENT_OPENER & sTemp & COMMENT_CLOSER & "\cf4\par"
                    sTemp = ""
                    bInComment = False
                ElseIf Not (bInString Or bInComment) Then
                    objAppend.Append FormatVBWord(sTemp) & TERMINAL_OPENER & Replace(sChar, vbCr, "\cf4  \par") & TERMINAL_CLOSER
                    sTemp = ""
                Else
                    sTemp = sTemp & Replace(sChar, " ", " ")
                End If

            Else
                sTemp = sTemp & sChar
            End If
       
        Next
        
        Dim s As String
        
        If IsNewLine Then
            If Right(objAppend.Data, 4) = "\par" Then
                s = objAppend.Data
                s = Left(s, Len(objAppend.Data) - 4)
            End If
            ProcessVB = s & "\cf0 " & sTemp  '   objAppend.Data & "\cf0 " & sTemp
            
        Else
            ProcessVB = objAppend.Data & "\cf0 " & sTemp
        End If
        
        'MsgBox Right(objAppend.Data, 4)
        
        'ProcessVB = s & "\cf0 " & sTemp  '   objAppend.Data & "\cf0 " & sTemp
        objAppend.Reset

        Set objAppend = Nothing
            
    End Function
    
    Private Function FormatVBWord(ByVal sInput As String)        'As String
        
        If InStr(1, StrConv(BlueKeyWords, vbLowerCase), "*" & StrConv(sInput, vbLowerCase) & "*") Then
           FormatVBWord = KEYWORD_OPENER & StrConv(sInput, vbProperCase) & KEYWORD_CLOSER
        Else
            FormatVBWord = sInput
        End If
            
       
    End Function
      
      
    Private Function IsVBTerminal(ByVal sChar)        'As Boolean
        Select Case sChar
            Case ".": IsVBTerminal = True
            Case "(": IsVBTerminal = True
            Case ")": IsVBTerminal = True
            Case "=": IsVBTerminal = True
            Case " ": IsVBTerminal = True
            Case vbTab: IsVBTerminal = True
            Case ",": IsVBTerminal = True
            Case vbCr: IsVBTerminal = True
            Case vbLf: IsVBTerminal = True
            Case vbCrLf: IsVBTerminal = True
            Case "-": IsVBTerminal = True
            Case "+": IsVBTerminal = True
            Case "/": IsVBTerminal = True
            Case "*": IsVBTerminal = True
            Case "\": IsVBTerminal = True
            Case "%": IsVBTerminal = True
            Case """": IsVBTerminal = True
            Case "'": IsVBTerminal = True
            Case Else: IsVBTerminal = False
        End Select
    End Function
    
    
    Private Function ProcessHTML(ByVal sInput)        'As String
              Const TAG_OPENER = "<font color='#aa00aa'>"
        Const STRING_OPENER = "<font color='#00aa33'>"
              Dim objAppend       As New Lib_AppendString
        
        Dim sOutput         As String
        Dim sTemp           As String
        Dim lCount          As Long
        Dim lMax            As Long
        Dim sChar           As String
        Dim bInString       As Boolean
        Dim bInComment      As Boolean
      
        lMax = Len(sInput)
       
        bInString = False
        bInComment = False
        
        For lCount = 1 To lMax
            sChar = Mid$(sInput, lCount, 1)
            If IsVBTerminal(sChar) Then
                If sChar = Chr(34) And bInString And Not bInComment Then        '== Close a string
                      objAppend.Append STRING_OPENER & Replace(sTemp & sChar, " ", TAG_OPENER & "&lt;") & STRING_CLOSER & "\cf4  "
                    bInString = False
                    sTemp = " "
                ElseIf sChar = Chr(34) And Not (bInString Or bInComment) Then '== Open a string
                    bInString = True
                    objAppend.Append FormatVBWord(sTemp) & "<\Font>"
                    sTemp = Chr(34)
                ElseIf Not (bInString Or bInComment) And sChar = "'" Then
                    bInComment = True
                    objAppend.Append FormatVBWord(sTemp) & "<\Font>"
                    sTemp = "'"
                ElseIf bInComment And sChar = vbCr Then
                    objAppend.Append COMMENT_OPENER & sTemp & COMMENT_CLOSER & "<\Font><br>"
                    sTemp = ""
                    bInComment = False
                ElseIf Not (bInString Or bInComment) Then
                    objAppend.Append FormatVBWord(sTemp) & TERMINAL_OPENER & Replace(sChar, vbCr, "<\Font><\br>")
                    sTemp = ""
                Else
                    sTemp = sTemp & Replace(sChar, " ", " ")
                End If

            Else
                sTemp = sTemp & sChar
            End If
       
        Next
        
        ProcessHTML = objAppend.Data & sTemp
        
        objAppend.Reset
        
        Set objAppend = Nothing
            

  
    End Function

            

    

